// ConsoleApplication1.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>

#include <map>
using namespace std;

class Class1
{
public:
    Class1(int id, int subid) : id(id), subid(subid) {};

    bool operator < (const Class1& rhs) const
    {
        if (id == rhs.id)
        {
            return subid < rhs.subid;
        }

        return id < rhs.id;
    }

private:
    int id;
    int subid;
};

int main()
{
    {
        Class1 c1(1, 5);
        map<Class1, int> c2int;
        c2int[c1] = 12;

        Class1 c2(1, 6);
        c2int[c2] = 16;

        Class1 c3(2, 6);
        c2int[c3] = 18;

        Class1 c4(2, 6);
        c2int[c4] = 20;

        for (auto iter = c2int.begin(); iter != c2int.end(); iter++)
        {
            std::cout << (*iter).second << endl;
        }
    }

    std::cout << endl;
}
