// ConsoleApplication2.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>

#include <map>
using namespace std;

class Class1
{
public:
    Class1(int id) : id(id) {};

private:
    int id;

    friend class Class1Compare;
    friend struct std::less<Class1>;
};

namespace std
{
    template<> struct less<Class1>
    {
        bool operator() (const Class1& lhs, const Class1& rhs) const
        {
            return lhs.id < rhs.id;
        }
    };
}

struct Class1Compare
{
    bool operator() (const Class1& lhs, const Class1& rhs) const
    {
        return lhs.id < rhs.id;
    }
};

int main()
{
    {
        Class1 c1(1);
        map<Class1, int> c2int;
        c2int[c1] = 12;
    }

    std::cout << "Hello World!\n";
}
